<script setup lang="ts">
import { ref } from 'vue';
import textHelper from '~~/utils/formatHelpers/textFormatHelper';
import dateTimeFormatHelper from '~~/utils/formatHelpers/dateTimeFormatHelper';

const props = defineProps({
    startDate: {
        type: String,
        default: false,
    },
    endDate: {
        type: String,
        default: {},
    },
    disabled: {
      type: Boolean,
      default: false
    },
    numberDateForDisable: {
      type: Number,
      default: 60,
    },
});

const emit = defineEmits([
  "update:startDate",
  "update:endDate",
  "visible-change",
]);
const originalDate = new Date(textHelper.getGmtMinusFourDate(String(new Date())));
const defaultDate = new Date(originalDate.getFullYear(), originalDate.getMonth(), originalDate.getDate(), 0, 0, 0);
const dateTimeRangeValue = ref([String(defaultDate), String(defaultDate)]);
watch(() => useRoute().fullPath , () => {
  dateTimeRangeValue.value = [String(defaultDate), String(defaultDate)];
});

watch(() => dateTimeRangeValue.value, () => {
  emit("update:startDate", dateTimeFormatHelper.formatTimestamp(dateTimeRangeValue.value[0]));
  emit("update:endDate", dateTimeFormatHelper.formatTimestamp(dateTimeRangeValue.value[1]));
});
const shortcuts = [
  {
    text: 'Today',
    value: () => {
      const { startDate, endDate } = commonHelper.getDateRange(
        'today',
        "yyyy/MM/dd HH:mm:ss"
      );
      return [textHelper.getGmtMinusFourDate(String(startDate)), textHelper.getGmtMinusFourDate(String(endDate))]
    },
  },
  {
    text: 'Yesterday',
    value: () => {
      const { startDate, endDate } = commonHelper.getDateRange(
        'yesterday',
        "yyyy/MM/dd HH:mm:ss"
      );
      return [textHelper.getGmtMinusFourDate(String(startDate)), textHelper.getGmtMinusFourDate(String(endDate))]
    },
  },
  {
    text: 'Past 3 Days',
    value: () => {
      const { startDate, endDate } = commonHelper.getDateRange(
        'past3days',
        "yyyy/MM/dd HH:mm:ss"
      );
      return [textHelper.getGmtMinusFourDate(String(startDate)), textHelper.getGmtMinusFourDate(String(endDate))]
    },
  },
];
const isShowDatePickerPanel = ref(false);
const enableNextButton = () => {
  const buttons = document.querySelectorAll(".el-picker-panel__icon-btn.arrow-right");
  buttons.forEach((button) => {
    button.classList.remove("is-disabled");
    (button as HTMLButtonElement).disabled = false;
  });
};

const disabledDate = (time: Date) => {
  const date = new Date();
  const nextDay = date.setDate(date.getDate());
  const previousSixtyDay = date.setDate(date.getDate() - props.numberDateForDisable);
  return nextDay < time.getTime() || previousSixtyDay > time.getTime();
};
const handleVisiblePopper = (event) => {
  emit('visible-change', event);
  isShowDatePickerPanel.value = !isShowDatePickerPanel.value;
}
watch(()=> isShowDatePickerPanel.value, () => {
  if (isShowDatePickerPanel.value) enableNextButton();
});

</script>

<template>
    <div>
      <el-date-picker
        v-model="dateTimeRangeValue"
        type="daterange"
        :shortcuts="shortcuts"
        range-separator="To"
        start-placeholder="Start date"
        end-placeholder="End date"
        popper-class="date-time-range-picker-desktop"
        :unlink-panels="true"
        :disabled="disabled"
        :disabled-date="disabledDate"
        :editable="false"
        class="date-time-range-picker-input"
        @visible-change="handleVisiblePopper"
      />
    </div>
</template>

<style scoped lang="scss">
:deep(.el-date-editor) {
    border: 1px solid var(--primary);
    border-radius: 4px;
    padding: 4px 8px;
  .el-range-input {
      background: none;
  }
  span {
      color: var(--text5);
  }
}
</style>

<style lang="scss">
.date-time-range-picker-desktop {
  .el-picker-panel__body-wrapper {
    background: var(--background5);
  }
  .el-picker-panel__sidebar {
    background: none;
  }
  .el-date-range-picker__time-header {
    display: none;
  }
  .el-date-table td.in-range .el-date-table-cell {
    background-color: var(--background5);
  }
  .el-date-table td.disabled .el-date-table-cell {
    background-color: var(--background5);
  }
  .el-date-table .el-date-table-cell {
    background-color: var(--background5);
  }
  .el-date-table td.start-date .el-date-table-cell {
    margin-left: 15px;
  }
  .el-date-table td.end-date .el-date-table-cell {
    margin-right: 15px;
  }
  .el-date-table td {
    .el-date-table-cell {
      padding-top: 0;
      height: 24px;
    }
    &.disabled .el-date-table-cell__text {
      opacity: 0.3;
    }
  }
  .el-date-range-picker.has-sidebar {
    width: 510px;
  }
  .el-picker-panel__content.el-date-range-picker__content.is-left {
    width: 400px;
  }
  .el-picker-panel__content.el-date-range-picker__content.is-right {
    display: none;
    width: 0;
  }
  .el-picker-panel__icon-btn {
    &.d-arrow-left,
    &.d-arrow-right {
      display: none;
    }
  }
  .el-picker-panel__icon-btn.is-disabled {
    opacity: 0.3;
  }
  .el-picker-panel__shortcut, .el-date-range-picker__header, .el-date-table, th {
    color: var(--text5) !important;
  }
}
.date-time-range-picker-input {
  &.el-date-editor.is-disabled {
    .el-range-input {
      color: var(--el-disabled-text-color);
    }
  }
  &.el-date-editor {
    .el-range-input {
      color: var(--text5);
    }
  }
}

</style>
